package vn.azteam.tpf.service.dto;

import java.time.Instant;
import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;
import java.util.Objects;

/**
 * A DTO for the TBCrop entity.
 */
public class TBCropDTO implements Serializable {

    private Long id;

    private String qrCode;

    private String code;

    private Double areaM2;

    private Long tbCropTypeId;

    private Instant startDate;

    private Instant endDate;

    private String status;

    private String description;

    private Integer ageDayStartAt;

    private Instant createdDate;

    private Instant modifiedDate;

    private Instant deletedDate;

    private Long tbSuppliesId;

    private String suppliesName;

    private Long tbGuidelineId;

    private Integer guidelineDuration;

    private Long netHouseId;

    private String netHouseName;

    private Long areaId;

    private String area;

    private Long createdById;

    private Long modifiedById;

    private Long deletedById;

    private Long tbCustomerId;

    private Long tbGuidelinePeriodId;

    private String tbGuidelinePeriodName;

    private Set<TBDetailUserDTO> tbDetailUsers = new HashSet<>();

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getQrCode() {
        return qrCode;
    }

    public void setQrCode(String qrCode) {
        this.qrCode = qrCode;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public Double getAreaM2() {
        return areaM2;
    }

    public void setAreaM2(Double areaM2) {
        this.areaM2 = areaM2;
    }

    public Long getTbCropTypeId() {
        return tbCropTypeId;
    }

    public void setTbCropTypeId(Long tbCropTypeId) {
        this.tbCropTypeId = tbCropTypeId;
    }

    public Instant getStartDate() {
        return startDate;
    }

    public void setStartDate(Instant startDate) {
        this.startDate = startDate;
    }

    public Instant getEndDate() {
        return endDate;
    }

    public void setEndDate(Instant endDate) {
        this.endDate = endDate;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Integer getAgeDayStartAt() {
        return ageDayStartAt;
    }

    public void setAgeDayStartAt(Integer ageDayStartAt) {
        this.ageDayStartAt = ageDayStartAt;
    }

    public String getSuppliesName() {
        return suppliesName;
    }

    public void setSuppliesName(String suppliesName) {
        this.suppliesName = suppliesName;
    }

    public String getNetHouseName() {
        return netHouseName;
    }

    public void setNetHouseName(String netHouseName) {
        this.netHouseName = netHouseName;
    }

    public Instant getCreatedDate() {
        return createdDate;
    }

    public void setCreatedDate(Instant createdDate) {
        this.createdDate = createdDate;
    }

    public Instant getModifiedDate() {
        return modifiedDate;
    }

    public void setModifiedDate(Instant modifiedDate) {
        this.modifiedDate = modifiedDate;
    }

    public Instant getDeletedDate() {
        return deletedDate;
    }

    public void setDeletedDate(Instant deletedDate) {
        this.deletedDate = deletedDate;
    }

    public Long getTbSuppliesId() {
        return tbSuppliesId;
    }

    public void setTbSuppliesId(Long tBSuppliesId) {
        this.tbSuppliesId = tBSuppliesId;
    }

    public Long getTbGuidelineId() {
        return tbGuidelineId;
    }

    public void setTbGuidelineId(Long tBGuidelineId) {
        this.tbGuidelineId = tBGuidelineId;
    }

    public Long getNetHouseId() {
        return netHouseId;
    }

    public void setNetHouseId(Long tBEntityId) {
        this.netHouseId = tBEntityId;
    }

    public Long getCreatedById() {
        return createdById;
    }

    public void setCreatedById(Long tBDetailUserId) {
        this.createdById = tBDetailUserId;
    }

    public Long getModifiedById() {
        return modifiedById;
    }

    public void setModifiedById(Long tBDetailUserId) {
        this.modifiedById = tBDetailUserId;
    }

    public Long getDeletedById() {
        return deletedById;
    }

    public void setDeletedById(Long tBDetailUserId) {
        this.deletedById = tBDetailUserId;
    }

    public Set<TBDetailUserDTO> getTbDetailUsers() {
        return tbDetailUsers;
    }

    public void setTbDetailUsers(Set<TBDetailUserDTO> tBDetailUsers) {
        this.tbDetailUsers = tBDetailUsers;
    }

    public Long getTbGuidelinePeriodId() {
        return tbGuidelinePeriodId;
    }

    public void setTbGuidelinePeriodId(Long tbGuidelinePeriodId) {
        this.tbGuidelinePeriodId = tbGuidelinePeriodId;
    }

    public String getTbGuidelinePeriodName() {
        return tbGuidelinePeriodName;
    }

    public void setTbGuidelinePeriodName(String tbGuidelinePeriodName) {
        this.tbGuidelinePeriodName = tbGuidelinePeriodName;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }

        TBCropDTO tBCropDTO = (TBCropDTO) o;
        if (tBCropDTO.getId() == null || getId() == null) {
            return false;
        }
        return Objects.equals(getId(), tBCropDTO.getId());
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getId());
    }

    @Override
    public String toString() {
        return "TBCropDTO{" +
            "id=" + getId() +
            ", qrCode='" + getQrCode() + "'" +
            ", code='" + getCode() + "'" +
            ", areaM2='" + getAreaM2() + "'" +
            ", tbCropTypeId=" + getTbCropTypeId() +
            ", startDate='" + getStartDate() + "'" +
            ", endDate='" + getEndDate() + "'" +
            ", status='" + getStatus() + "'" +
            ", description='" + getDescription() + "'" +
            ", ageDayStartAt=" + getAgeDayStartAt() +
            ", createdDate='" + getCreatedDate() + "'" +
            ", modifiedDate='" + getModifiedDate() + "'" +
            ", deletedDate='" + getDeletedDate() + "'" +
            ", tbSupplies=" + getTbSuppliesId() +
            ", tbGuideline=" + getTbGuidelineId() +
            ", tbEntity=" + getNetHouseId() +
            ", tbEntity=" + getTbCustomerId() +
            ", createdBy=" + getCreatedById() +
            ", modifiedBy=" + getModifiedById() +
            ", deletedBy=" + getDeletedById() +
            "}";
    }

    public String getArea() {
        return area;
    }

    public void setArea(String area) {
        this.area = area;
    }

    public Long getAreaId() {
        return areaId;
    }

    public void setAreaId(Long areaId) {
        this.areaId = areaId;
    }

    public Long getTbCustomerId() {
        return tbCustomerId;
    }

    public void setTbCustomerId(Long tbCustomerId) {
        this.tbCustomerId = tbCustomerId;
    }

    public Integer getGuidelineDuration() {
        return guidelineDuration;
    }

    public void setGuidelineDuration(Integer guidelineDuration) {
        this.guidelineDuration = guidelineDuration;
    }
}
